import { OnInit, ElementRef, Renderer2, SimpleChanges, OnChanges, NgZone, EventEmitter } from '@angular/core';
import { NgxBootstrapTreeviewContextMenuConfig } from '../../models/ngx-bootstrap-treeview-context-menu-config.model';
import { NgxBootstrapTreeviewContextMenuActions } from '../../models/ngx-bootstrap-treeview-context-menu-actions.model';
import { ContextMenuService } from '../../services/context-menu.service';
import { ContextMenuEvent } from '../../models/context-menu-event.model';
export declare class NgxBootstrapTreeviewContextMenuComponent implements OnInit, OnChanges {
    private _renderer;
    private _zone;
    private _contextMenuService;
    _defaultConfig: NgxBootstrapTreeviewContextMenuConfig;
    config: NgxBootstrapTreeviewContextMenuConfig;
    rootContextMenu: NgxBootstrapTreeviewContextMenuActions;
    branchContextMenu: NgxBootstrapTreeviewContextMenuActions;
    leafContextMenu: NgxBootstrapTreeviewContextMenuActions;
    hidden: EventEmitter<void>;
    shown: EventEmitter<void>;
    container: ElementRef<HTMLDivElement>;
    private _activeMenu;
    lastContextMenuEvent: ContextMenuEvent;
    constructor(_renderer: Renderer2, _zone: NgZone, _contextMenuService: ContextMenuService);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    onDocumentClicked(event: Event): void;
    onKeyPressed(event: KeyboardEvent): void;
    getLabels(): string[];
    onItemClicked(label: string): void;
    hide(): void;
    show(contextMenuEvent: ContextMenuEvent): void;
}
