import { OnInit, EventEmitter, QueryList, ElementRef, Renderer2, SimpleChanges, OnChanges, NgZone, ChangeDetectorRef } from '@angular/core';
import { Tree } from '../../models/tree.model';
import { IconDefinition } from '@fortawesome/free-solid-svg-icons';
import { Leaf } from '../../models/leaf.model';
import { LeafClickedEvent } from '../../models/leaf-clicked-event.model';
import { ILoggingService } from '../../interfaces/ILoggingService.interface';
import { NgxBootstrapTreeviewMapper } from '../../utils/ngx-bootstrap-treeview-mapper';
import { NgxBootstrapTreeviewContextMenus } from '../../models/ngx-bootstrap-treeview-context-menus.model';
import { ContextMenuService } from '../../services/context-menu.service';
export declare class NgxBootstrapTreeviewComponent implements OnInit, OnChanges {
    private _host;
    private _renderer;
    private _zone;
    private _changeDetector;
    private _contextMenuService;
    canSelectBranch: boolean;
    contextMenus: NgxBootstrapTreeviewContextMenus;
    disableSelectedElements: boolean;
    emptyFolderLabel: string;
    isAnimationDisabled: boolean;
    isFirstLevel: boolean;
    isFirstInstance: boolean;
    isOpened: boolean;
    item: Object;
    items: Object[];
    loggingService: ILoggingService;
    mapper: NgxBootstrapTreeviewMapper<Object, Object>;
    preselectedItems: any[];
    tree: Tree;
    trees: Tree[];
    openedFolderIcon: IconDefinition;
    closedFolderIcon: IconDefinition;
    unselectedLeafIcon: IconDefinition;
    selectedLeafIcon: IconDefinition;
    anyChildrenSelectedIcon: IconDefinition;
    allChildrenSelectedIcon: IconDefinition;
    filterString: string;
    matchBranches: boolean;
    branchClicked: EventEmitter<Tree>;
    leafClicked: EventEmitter<LeafClickedEvent>;
    children: QueryList<NgxBootstrapTreeviewComponent>;
    treeview: ElementRef<HTMLUListElement>;
    rootsContainer: ElementRef<HTMLDivElement>;
    selectedLeaves: Leaf[];
    leavesCount: number;
    isBranch: boolean;
    isLeaf: boolean;
    isRoot: boolean;
    displayedTrees: Tree[];
    displayedTree: Tree;
    private _filterTrigger;
    constructor(_host: ElementRef<HTMLElement>, _renderer: Renderer2, _zone: NgZone, _changeDetector: ChangeDetectorRef, _contextMenuService: ContextMenuService);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    onClick(): void;
    onChildLeafClicked(leafClickedEvent: LeafClickedEvent): void;
    onLeafClicked(): void;
    countLeaves(tree: Tree): number;
    select(value: any): void;
    unselect(value: any): void;
    onBranchClicked(): void;
    onChildBranchClicked(branch: Tree): void;
    onContextMenu(event: MouseEvent): void;
    onElementAdded(): boolean;
    onRootContextMenu(event: MouseEvent): void;
    fold(id?: number | string): void;
    unfold(id?: number | string): void;
    show(): void;
    hide(): void;
    filter(filterString: string, item?: Tree): void;
    countFilteredItems(filterString: string, item: Tree): number;
    unfoldAll(): void;
    foldAll(): void;
    computeHeight(): number;
    private _unfold;
    private _fold;
    private _unfoldId;
    private _foldId;
    private _leafToggle;
    private _branchToggle;
    private _selectLeaf;
    private _unselectLeaf;
    private _leafIndex;
    private _leafExistsIn;
    private _copyTree;
    private _copyTrees;
    private _filterTrees;
    private _filterTree;
    private _resetDisplayedData;
}
